/**
 ****************************************************************************
 * Driver for Texas Instrument TPS65023 PMU driver.
 *
 * @file   include/tps65023_itf.h
 * @brief  TPS65023 PMU API Header.
 *
 * Code is based on the DS_tps65023.pdf in the doc directory of this package
 *
 * @author Yves LEMOINE
 * @date   2007-04-23
 *
 * Copyright (C) 2007, Parrot S.A. - www.parrot.com
 ****************************************************************************
 */

#ifndef _TPS65023_API_
#define _TPS65023_API_


extern void pmu_tps65023_init(void);
extern void tps65023_i2c_write ( cyg_uint8 addr , cyg_uint8 data);
extern void tps65023_i2c_read ( cyg_uint8 addr , cyg_uint8 * data);
void tps65023_set_core_voltage ( cyg_uint32 mVCore);

#endif