//==========================================================================
//
//      io/serial/arm/arm_arm9_p6dev_ser.inl
//
//      P6DEV Serial I/O definitions
//
//==========================================================================
//
// Author(s):    ivan.djelic@parrot.fr
// Date:         2005-11-17
// Purpose:      P6dev Serial I/O module
// Description:
//
//==========================================================================

#include <cyg/hal/hal_intr.h>
#include <cyg/hal/p6dev.h>

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL0

static parrot5_serial_info p6dev_serial_info0 = {
  PARROT6_UART0, P6_SYS_CLK_UART0, CYGNUM_HAL_INTERRUPT_UART0,
};

#if CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL0_BUFSIZE > 0
static unsigned char
p6dev_serial_out_buf0[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL0_BUFSIZE];
static unsigned char
p6dev_serial_in_buf0[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL0_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p6dev_channel_serial0,
				 parrot5_serial_funs,
				 p6dev_serial_info0,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL0_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p6dev_serial_out_buf0[0],
				 sizeof(p6dev_serial_out_buf0),
				 &p6dev_serial_in_buf0[0],
				 sizeof(p6dev_serial_in_buf0));
#else
static SERIAL_CHANNEL( p6dev_channel_serial0,
		       parrot5_serial_funs,
		       p6dev_serial_info0,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL0_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p6dev_serial_io0,
             CYGDAT_IO_SERIAL_ARM_P6DEV_SERIAL0_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p6dev_channel_serial0 );
#endif //  CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL0

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL1

static parrot5_serial_info p6dev_serial_info1 = {
  PARROT6_UART1, P6_SYS_CLK_UART1, CYGNUM_HAL_INTERRUPT_UART1,
};

#if CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL1_BUFSIZE > 0
static unsigned char
p6dev_serial_out_buf1[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL1_BUFSIZE];
static unsigned char
p6dev_serial_in_buf1[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL1_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p6dev_channel_serial1,
				 parrot5_serial_funs,
				 p6dev_serial_info1,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL1_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p6dev_serial_out_buf1[0],
				 sizeof(p6dev_serial_out_buf1),
				 &p6dev_serial_in_buf1[0],
				 sizeof(p6dev_serial_in_buf1));
#else
static SERIAL_CHANNEL( p6dev_channel_serial1,
		       parrot5_serial_funs,
		       p6dev_serial_info1,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL1_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p6dev_serial_io1,
             CYGDAT_IO_SERIAL_ARM_P6DEV_SERIAL1_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p6dev_channel_serial1 );
#endif //  CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL1

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL2

static parrot5_serial_info p6dev_serial_info2 = {
  PARROT6_UART2, P6_SYS_CLK_UART2, CYGNUM_HAL_INTERRUPT_UART2,
};

#if CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL2_BUFSIZE > 0
static unsigned char
p6dev_serial_out_buf2[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL2_BUFSIZE];
static unsigned char
p6dev_serial_in_buf2[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL2_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p6dev_channel_serial2,
				 parrot5_serial_funs,
				 p6dev_serial_info2,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL2_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p6dev_serial_out_buf2[0],
				 sizeof(p6dev_serial_out_buf2),
				 &p6dev_serial_in_buf2[0],
				 sizeof(p6dev_serial_in_buf2));
#else
static SERIAL_CHANNEL( p6dev_channel_serial2,
		       parrot5_serial_funs,
		       p6dev_serial_info2,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL2_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p6dev_serial_io2,
             CYGDAT_IO_SERIAL_ARM_P6DEV_SERIAL2_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p6dev_channel_serial2 );
#endif //  CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL2

//-----------------------------------------------------------------------------

#ifdef CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL3

static parrot5_serial_info p6dev_serial_info3 = {
  PARROT6_UART3, P6_SYS_CLK_UART3, CYGNUM_HAL_INTERRUPT_UART3,
};

#if CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL3_BUFSIZE > 0
static unsigned char
p6dev_serial_out_buf3[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL3_BUFSIZE];
static unsigned char
p6dev_serial_in_buf3[CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL3_BUFSIZE];

static
SERIAL_CHANNEL_USING_INTERRUPTS( p6dev_channel_serial3,
				 parrot5_serial_funs,
				 p6dev_serial_info3,
				 CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL3_BAUD),
				 CYG_SERIAL_STOP_DEFAULT,
				 CYG_SERIAL_PARITY_DEFAULT,
				 CYG_SERIAL_WORD_LENGTH_DEFAULT,
				 CYG_SERIAL_FLAGS_DEFAULT,
				 &p6dev_serial_out_buf3[0],
				 sizeof(p6dev_serial_out_buf3),
				 &p6dev_serial_in_buf3[0],
				 sizeof(p6dev_serial_in_buf3));
#else
static SERIAL_CHANNEL( p6dev_channel_serial3,
		       parrot5_serial_funs,
		       p6dev_serial_info3,
		       CYG_SERIAL_BAUD_RATE(CYGNUM_IO_SERIAL_ARM_P6DEV_SERIAL3_BAUD),
		       CYG_SERIAL_STOP_DEFAULT,
		       CYG_SERIAL_PARITY_DEFAULT,
		       CYG_SERIAL_WORD_LENGTH_DEFAULT,
		       CYG_SERIAL_FLAGS_DEFAULT );
#endif

DEVTAB_ENTRY(p6dev_serial_io3,
             CYGDAT_IO_SERIAL_ARM_P6DEV_SERIAL3_NAME,
             0,                  // Does not depend on a lower level interface
             &cyg_io_serial_devio,
             parrot5_serial_init,
             parrot5_serial_lookup,     // Serial driver may need initializing
             &p6dev_channel_serial3 );
#endif //  CYGPKG_IO_SERIAL_ARM_P6DEV_SERIAL3

//-----------------------------------------------------------------------------
// EOF arm_arm9_p6dev_ser.inl
