#ifndef CYGONCE_ARM_SMDK2412_SERIAL_H
#define CYGONCE_ARM_SMDK2412_SERIAL_H

// ====================================================================
//
//      smdk2412_serial.h
//
//      Device I/O - Description of Samsung SMDK2412 serial hardware
//
// ====================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
// ====================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    michael anburaj <michaelanburaj@hotmail.com>
// Contributors: michael anburaj <michaelanburaj@hotmail.com>
// Date:         2003-08-01
// Purpose:      Internal interfaces for serial I/O drivers
// Description:
//
//####DESCRIPTIONEND####
//
// ====================================================================

enum
{
    VAL_ULCON_WL_5 = 0,
    VAL_ULCON_WL_6,
    VAL_ULCON_WL_7,
    VAL_ULCON_WL_8
};

enum 
{
    VAL_ULCON_SB_1 = 0,    // 1 stop bit
    VAL_ULCON_SB_2 = 4     // 2 stop bits
};

enum
{
    VAL_ULCON_PM_N = 0,			// No parity
    VAL_ULCON_PM_O = 1<<3,		// Odd parity
    VAL_ULCON_PM_E = 2<<3,		// Even parity
    VAL_ULCON_PM_FC1 = 3<<3,	// Mark parity
    VAL_ULCON_PM_FC0 = 4<<3		// Space parity
};

static unsigned char select_word_length[] = {
    VAL_ULCON_WL_5,
    VAL_ULCON_WL_6,
    VAL_ULCON_WL_7,
    VAL_ULCON_WL_8
};

static unsigned char select_stop_bits[] = {
    0,                 // Unused
    VAL_ULCON_SB_1,    // 1 stop bit
    0,                 // 1.5 stop bit (not supported)
    VAL_ULCON_SB_2     // 2 stop bits
};

static unsigned char select_parity[] = {
    VAL_ULCON_PM_N,     // No parity
    VAL_ULCON_PM_E,     // Even parity
    VAL_ULCON_PM_O,     // Odd parity
    VAL_ULCON_PM_FC1,   // Mark parity
    VAL_ULCON_PM_FC0,   // Space parity
};

static unsigned int select_baud_rate[] = {
    0,
    50,
    75,
    110,
    134,
    150,
    200,
    300,
    600,
    1200,
    1800,
    2400,
    3600,
    4800,
    7200,
    9600,
    14400,
    19200,
    38400,
    57600,
    115200,
    230400,
    460800,
    921600,
	1500000,	
	2000000,	
	3000000,	

};

#define SMDK2412_SERIAL_FLAG_EXTCLOCK	1
#define SMDK2412_SERIAL_FLAG_RTSCTS		2
#define SMDK2412_SERIAL_FLAG_AFC		4

#endif // CYGONCE_ARM_SMDK2412_SERIAL_H
