#ifndef CYGONCE_CORTEXA_OMAP3630_SERIAL_H
#define CYGONCE_CORTEXA_OMAP3630_SERIAL_H

#include <cyg/hal/hal_io.h>  // Register definitions

// ====================================================================
// Translate system word length selector into local values.

static cyg_uint32 select_word_length[] = {
    0,
    1,
    2,
    3,
};

// ====================================================================
// Translate system stop bit selector into control register bits.

static cyg_uint32 select_stop_bits[] = {
    0,  // 0.5 stop bits not supported
    0,  // 1 stop bit
    1,  // 1.5 stop bit
    0,  // 2 stop bit not supported
};

// Translate system parity selector into local values.
static cyg_uint32 select_parity[] = {
    0,  // No parity
    3,  // Even parity
    2,  // Odd parity
    0,  // Mark (1) parity -- not supported
    0   // Space (0) parity -- not supported
};

// ====================================================================
// Translate system baud selector into direct baud rate value. This is
// then used to calculate the clock divisor from the PCLK clock.

static cyg_uint32 select_baud[] = {
    0,
    50,
    75,
    110,
    0,
    150,
    200,
    300,
    600,
    1200,
    1800,
    2400,
    3600,
    4800,
    7200,
    9600,
    14400,
    19200,
    38400,
    57600,
    115200,
    230400,
    460800,
    921600,
};

// ====================================================================
#endif // CYGONCE_CORTEXA_OMAP3630_SERIAL_H
