/* this is a simple hello world program */
#include <stdio.h>

#include <cyg/hal/hal_intr.h> // Interrupt names
#include <cyg/hal/hal_io.h>
#include <cyg/kernel/kapi.h>  // thread
#include <cyg/kernel/diag.h>
#include <cyg/hal/hal_arch.h>           /* CYGNUM_HAL_STACK_SIZE_TYPICAL */

#include <unistd.h>
#include <cyg/fileio/fileio.h>
#include <dirent.h>
#include <errno.h>
#include <cyg/hal/hal_diag.h> // for HAL_DELAY_US
#include <cyg/hal/hal_io.h>     // for HAL_WRITE_UINT32
#include <cyg/crc/crc.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

#include "vfatfs_test.h"

#define NTHREADS 2
#define STACKSIZE ( CYGNUM_HAL_STACK_SIZE_TYPICAL + 4096 )


static char test_buf[5000];


/**************************************************** 
 * fct_test_short_names
 * --------------------------------------------------
 * ce test cree un desordre qui permet de tester l'algo
 * de gnration des noms de short entry
 ****************************************************/
void fct_test_short_names(void)
{
      int i_tab, nb_filename;
      int nb_err;
      int nb_files = 0;
      char str[1024];

      char* tab_name[] ={
/*00*/   "RINOCEROSE - 6ENTRYKILLS ME - Brian Jones- Last Picture.ogg",
/*01*/   "RINOCEROSE - 4ENTRYKILLS ME - Dead.ogg",
/*02*/   "RINOCEROSE - 6ENTRYKILLS ME - Dead Flowers.ogg",
/*03*/   "RINOCEROSE - 5ENTRYKILLS ME - Highway to Heaven.ogg",
/*04*/   "RINOCEROSE - 6ENTRYKILLS ME - It's Time to Go Now!.ogg",
/*05*/   "RINOCEROSE - 6ENTRYKILLS ME - Le Rock Summer [Edit].ogg",
/*06*/   "RINOCEROSE - 5ENTRYKILLS ME - Lost Love.ogg",
/*07*/   "RINOCEROSE - 5ENTRYKILLS ME - Music Kills Me.ogg",
/*08*/   "RINOCEROSE - 6ENTRYKILLS ME - No, We Are Not Experienced!.ogg",
/*09*/   "RINOCEROSE - 6ENTRYKILLS ME - Obseques d'un Guitar Hero.ogg",
/*10*/   "RINOCEROSE -21ENTRYKILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Profess",
/*11*/   "RINOCEROSE - 6ENTRYKILLS ME - Resurrection d'Une Idole Pop.ogg",
/*12*/   "RINOCEROSE - MUSIC KILLS ME - onteste.ogg",
         NULL  };


      nb_files  = 0;
      i_tab = 0;

      while(tab_name[i_tab] != NULL)
         i_tab++;

      nb_filename = i_tab;
      diag_printf("[I] %d Noms de fichiers\n", nb_filename);

      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
      if( nb_files != 0);
      {
         nb_files = 0;
         rm_dir("/");
      }

      nb_err = 0;
      for(i_tab=0; i_tab<(nb_filename-1); i_tab++)
      {
         nb_err += test_fatfs_open(tab_name, i_tab);
      }
      assert (nb_err == 0);

      nb_files = 0;
      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
      diag_printf("[I] %d/%d Fichiers listes\n", nb_files, nb_filename);

      sprintf(str,"/%s", tab_name[3]); rm(str);
      sprintf(str,"/%s", tab_name[2]); rm(str);

      test_fatfs_open(tab_name, 12);

      for(i_tab=0; i_tab<nb_filename; i_tab++)
      {
         sprintf(str,"/%s", tab_name[i_tab]);
         nb_err += rm(str);
      }

      nb_files = 0;
      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
      if( nb_files != 0);
      {
         nb_files = 0;
         rm_dir("/");
      }

}



/****************************************************
 * fct_test_max_char
 * --------------------------------------------------
 * creates a file which length is around the limites
 ****************************************************/
void fct_test_max_char(void)
   {
      int i_tab, nb_filename;
      int nb_err;
      int nb_files;
      char str[1024];

      char* tab_name[] =
/*00*/{  "RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeurttt",
/*01*/   "RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeur Suicide.ogg RINOCEROSE - MUSIC KILLS ME - Professeurtttt",
         NULL
      };

      i_tab = 0;
      while(tab_name[i_tab] != NULL)
         i_tab++;

      nb_filename = i_tab;
      diag_printf("[I] %d Noms de fichiers\n", nb_filename);

      /* Creation des fichiers de la table */
      /*-----------------------------------*/
      nb_files = 0;
      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
      if(nb_files >= 0)
      {
         rm_dir("/");
         diag_printf("[I] %d fichiers n'avaient pas ete effaces\n", nb_files);
      }

      nb_err = test_fatfs_open(tab_name, 0);
      assert(nb_err == 0);
      nb_err = test_fatfs_open(tab_name, 1);

      assert(nb_err == 1);
      if(nb_err == 1)
         diag_printf("[I] This namelen file was 256, that's why it can't have been opened\n", nb_files);
      else
         diag_printf("[I] This namelen file was 256, it shouldn't have been opened\n", nb_files);

      nb_files = 0;
      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);

      sprintf(str,"/%s", tab_name[0]);
      nb_err = rm(str);

      sprintf(str,"/%s", tab_name[1]);
      nb_err = rm(str);
      diag_printf("[I] This namelen file was 256, it hasn't been created so it can't be removed\n", nb_files);

      nb_files = 0;
      nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
}

/**************************************************** 
 * fct_test_writeread
 * --------------------------------------------------
 ****************************************************/
void fct_test_writeread(void)
{
   FILE * f;
   int i_tab, nb_filename;
   char str[1024];
   int fd;
   int i, j;
   cyg_uint32 crc_write;
   cyg_uint32 crc_read;
   cyg_uint32 length;
   int ret;
   int n;
   int nb_err = 0;
   int nb_test = 0;
   int nb_files = 0;

   char g_char = 0;


    char* tab_name[] =
/*00*/   {  "testfile.txt",
            NULL
         };

   i_tab = 0;
   while(tab_name[i_tab] != NULL)
      i_tab++;

   nb_filename = i_tab;
   diag_printf("[I] %d Noms de fichiers\n", nb_filename);

   sprintf(str,"/%s", tab_name[0]);

   while(nb_test < 10 ) 
   {
      g_char++;
      unlink(str);

      /* File opening/creation */
      fd = open(str, O_WRONLY | O_CREAT | O_TRUNC);
      assert(fd != -1);
      cyg_posix_crc_start(&crc_write, &length);
      for (i = 0; i < 40; i++) 
      {
         // gen random
         for (j = 0; j < sizeof(test_buf); j++) {
            test_buf[j] = rand();
         }
         memset(test_buf, g_char, sizeof(test_buf));

         // write
         cyg_posix_crc_cont(&crc_write, &length, test_buf, sizeof(test_buf));
         ret = write(fd, test_buf, sizeof(test_buf));
      }
      close(fd);
      fd = -1;
      cyg_posix_crc_end(&crc_write, &length);

      /* File checking  */
      f = fopen(str, "rb");
      assert(f);
      cyg_posix_crc_start(&crc_read, &length);
      while ((n = fread(test_buf, 1, sizeof(test_buf), f)) != 0)
         cyg_posix_crc_cont(&crc_read, &length, test_buf, n);
      cyg_posix_crc_end(&crc_read, &length);
      fclose(f);
      f = NULL;

   
      printf("TEST n%u ", nb_test);

      if (crc_read != crc_write) 
      {
         printf("\nCRC write = %u\n", crc_write);
         printf("CRC read = %u length=%u\n", crc_read, length);
         printf(" ----------------- CRC ERROR  !!!!!!!!!#\n");
         nb_err++;
         assert(nb_err == 0);
      } 
      else 
      {
         printf(" ----------------- CRC OK\n");
      }
      nb_test++;
   }

   printf("Nb Tests = %u - Nb Errors = %u\n", nb_test, nb_err);

   rm(str);

   /* Listing files */
   nb_files = 0;
   nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
   if( nb_files != 0)
      nb_err++;

   assert(nb_err == 0);
}


/**************************************************** 
 * fct_test_mktree
 * --------------------------------------------------
 * This function creates a dir tree and removes it
 ****************************************************/
#define NB_DIR    5
#define NB_FILE   10
void fct_test_mktree(void)
{
   FILE * f;
   int i_dir, i_file;
   int nb_files  = 0;
   char str[1024];
   char *dir_name/*[255+1]*/;


   nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
   diag_printf( "[I] - %d Files found\n", nb_files);

   /* Creation of NB_FILE within NB_DIR */
   nb_files = 0;
   for(i_dir=0; i_dir<NB_DIR; i_dir++)
   {
      dir_name = mk_dirname(i_dir);
      mkdir(dir_name,0);
      nb_files++;

      for(i_file=0; i_file<NB_FILE; i_file++)
      {
         sprintf( str, "%s/%s", dir_name,mk_filename(i_file) );
         f = fopen(str, "w");
         assert(f);
         nb_files++;
         fclose(f);
      }
   }
   /* Checking the number of files created */
   diag_printf( "[I] - %d Files opened\n", nb_files);
   assert( nb_files == NB_DIR*NB_FILE+NB_DIR );

   /* Removing all files and dirs */
   rm_dir("/");
   /* Checking the number of files removeded */
   diag_printf( "[I] - Removing Files ...\n");

   /* Listing files */
   nb_files = 0;
   nb_files = ls_recurs("/", RECURS_ON, PRINT_ON);
   diag_printf( "[I] - %d Files found\n", nb_files);
   assert( nb_files == 0 );

}



/**************************************************** 
 * SDMain_TU
 * --------------------------------------------------
 * Main test function
 ****************************************************/
void SDMain_TU( void )
{
   int n;

   /* test de l'algo de generation des shortname */
   diag_printf("<================== Checking Short Entry Name Generation ========>\n");
   diag_printf("------- Verification must be done examinating raw datas of the fat\n");
   n = mount("/dev/sdcard", "/", "fatfs");
   if (n != 0) 
      {diag_printf("mount error\n");assert( n == 0);}
   else
   {
      fct_test_short_names();
      umount("/");
   }
   diag_printf("<================== Checking Short Entry Name Generation Endded =>\n");

   /* test de l'algo de generation des shortname */
   diag_printf("<================== Checking Name Limits ========================>\n");
   diag_printf("------- This test gonna try to create a 255 and a 256 chars long name\n");
   diag_printf("------- then to remove them\n");
   n = mount("/dev/sdcard", "/", "fatfs");
   if (n != 0) 
      {diag_printf("mount error\n");assert( n == 0);}
   else
   {
      fct_test_max_char();
      umount("/");
   } 
   diag_printf("<================== Checking Name Limits Endded =================>\n");

   /* test de l'algo de generation des shortname */
   diag_printf("<================== Checking File Contents ======================>\n");
   diag_printf("------- This test gonna create a file with data, compute a CRC\n");
   diag_printf("------- then then it will read it and check the CRC \n");
   n = mount("/dev/sdcard", "/", "fatfs");
   if (n != 0) 
      {diag_printf("mount error\n");assert( n == 0);}
   else
   {
      fct_test_writeread();
      umount("/");
   }
   diag_printf("<================== Checking File Contents Endded================>\n");

   /* test de creation de destruction d'une arborescence */
   diag_printf("<================== Checking Tree Creation and deletion =========>\n");
   n = mount("/dev/sdcard", "/", "fatfs");
   if (n != 0) 
      {diag_printf("mount error\n");assert( n == 0);}
   else
   {
      fct_test_mktree();
      umount("/");
   }
   diag_printf("<================== Checking Tree Creation and deletion endded===>\n");

}
