#ifndef MEMCFG_H
#define MEMCFG_H
//=============================================================================
//
//      memcfg.h
//
//      Samsung SMDK2412 specific memory configuration
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    michael anburaj <michaelanburaj@hotmail.com>
// Contributors: michael anburaj <michaelanburaj@hotmail.com>
// Date:         2003-08-01
// Purpose:      ARM9/SMDK2412 platform specific memory configuration
// Description: 
// Usage:        #include <cyg/hal/memcfg.h>
//     Only used by "hal_platform_setup.h"         
//
//####DESCRIPTIONEND####
//
//=============================================================================

#include <pkgconf/hal_arm_arm9_smdk2412.h>

#define BANKCFG_VALUE	(2<<17) | (2<<14) | (1<<11) | (1<<8) | (0<<6) | (0<<4) | (1<<2) | (0<<0)
#define BANKCON1_VALUE	(1<<6) | (0<<5) | (0<<4)
#define BANKCON2_VALUE	(5<<20) | (7<<16) | (3<<4) | (2<<2) | (2<<0)
#define BANKCON3_VALUE	(2<<30) | (0<<21) | (0<<16) | (0<<14) | (0<<7) | (3<<4)
#define REFRESH_VALUE	787

#define		Mode_USR		0x10
#define		Mode_FIQ		0x11
#define		Mode_IRQ		0x12
#define		Mode_SVC		0x13
#define		Mode_ABT		0x17
#define		Mode_UND		0x1B
#define		Mode_SYS		0x1F

#define		I_Bit			0x80 // when I bit is set, IRQ is disabled
#define		F_Bit			0x40 // when F bit is set, FIQ is disabled
#define		Len_FIQ_Stack		256
#define		Len_IRQ_Stack		256
#define		Len_ABT_Stack		256
#define		Len_UND_Stack		256
#define		Len_SVC_Stack		1024

//Offsets will be loaded as immediate values.
//Offsets must be 8 byte aligned.

#define		Offset_FIQ_Stack		0
#define		Offset_IRQ_Stack		Offset_FIQ_Stack + Len_FIQ_Stack
#define		Offset_ABT_Stack		Offset_IRQ_Stack + Len_IRQ_Stack
#define		Offset_UND_Stack		Offset_ABT_Stack + Len_ABT_Stack
#define		Offset_SVC_Stack		Offset_UND_Stack + Len_UND_Stack

//-----------------------------------------------------------------------------
// end of memcfg.h
#endif // MEMCFG_H
