#ifndef TASK_PRIORITIES_H
#define TASK_PRIORITIES_H
/**
 * @file   task_priorities.h
 * @brief  Parrot Software Tasks Definition
 *
 * @author gregoire.etienne@parrot.com
 * @date   2008-04-01
 *
 * Copyright (C) 2004-2008 Parrot S.A.
 */
// #include <task_priorities.h>
/**
 * eCos priorities definition
 */
#define PRIO_ECOS_CAN_ISO_CB            1
#define PRIO_ECOS_LCD_R61505U           1
#define PRIO_ECOS_POWER                 1
#define PRIO_ECOS_CPULOAD               1
#define PRIO_ECOS_USB_AUDIO_NTF         1
#define PRIO_ECOS_WIFI_SDIO_OBSERVER    2
#define PRIO_ECOS_LPO_MONITOR           4
#define PRIO_ECOS_BUTTON_MONITOR        4
#define PRIO_ECOS_CS42XX_MONITOR        4
#define PRIO_ECOS_WIFI_SES_SIGALARM     5
#define PRIO_ECOS_WIFI_SCHEDULER        8
#define PRIO_ECOS_DEVMAN_NOTIF          11
#define PRIO_ECOS_DEVMAN_SDCARD_NOTIF   PRIO_ECOS_DEVMAN_NOTIF
#define PRIO_ECOS_FS_PFFS_GC            30
#define PRIO_ECOS_RFTPD                 30


#define PRIO_ECOS_USB_REAPER            2
#define PRIO_ECOS_USB_BASE              3 //creates 3 threads with prio 3, 4, 5
#define PRIO_ECOS_USB_MASS_STORAGE      6


#define PRIO_ECOS_NET_BNEP_SENDER       5
#define PRIO_ECOS_NET_ALARM             (PRIO_ECOS_NET_BASE-1)
#define PRIO_ECOS_NET_BASE              7
#define PRIO_ECOS_NET_DHCP              (PRIO_ECOS_NET_BASE+1)
#define PRIO_ECOS_NET_SNMP              (PRIO_ECOS_NET_BASE+1)
#define PRIO_ECOS_NET_SNTP              (PRIO_ECOS_NET_BASE+1)
#define PRIO_ECOS_NET_IPV6_ROUTING      (PRIO_ECOS_NET_BASE+1)
#define PRIO_ECOS_NET_TFTPD             10
#define PRIO_ECOS_NET_PPP_PPPD          15
#define PRIO_ECOS_NET_PPP_TX            (PRIO_ECOS_NET_PPP_PPPD+1)

/** 
 * Tala priority
 */
#define PRIO_TALA                   3

/**
 * Tango priorities definition
 */
#define PRIO_TANGO_MMP_AUDIOOUT     4
#define PRIO_TANGO_MMP_AUDIOIN_DRV  4

#define PRIO_TANGO_SCHEDULER        10
#define PRIO_TANGO_BASE             11

#define PRIO_TANGO_ACQRES           11
#define PRIO_TANGO_DSP_CANC_RX      12
#define PRIO_TANGO_DFFT             12
#define PRIO_TANGO_RESTIT           12
#define PRIO_TANGO_DSP_CANC_TX      13
#define PRIO_TANGO_DSP_NR           14
#define PRIO_TANGO_PHAROS           15

#define PRIO_TANGO_MMP_WSP_RESAMP   11
#define PRIO_TANGO_MMP_AUDIOBUFFER  12

#define PRIO_TANGO_MMP_ENCODER      (PRIO_TANGO_MMP_AUDIOBUFFER) /*12*/
#define PRIO_TANGO_MMP_MONOREDUC    (PRIO_TANGO_MMP_AUDIOBUFFER) /*12*/

#define PRIO_TANGO_MMP_EQUALIZER    (PRIO_TANGO_MMP_AUDIOBUFFER + 1) /*13*/
#define PRIO_TANGO_MMP_LIMITER      (PRIO_TANGO_MMP_AUDIOBUFFER + 2) /*14*/
#define PRIO_TANGO_MMP_VBASS        (PRIO_TANGO_MMP_AUDIOBUFFER + 3) /*15*/

#define PRIO_TANGO_MMP_SPATIAL      (PRIO_TANGO_MMP_AUDIOBUFFER + 4) /*16*/
#define PRIO_TANGO_MMP_CARSPATIAL   (PRIO_TANGO_MMP_AUDIOBUFFER + 4) /*16*/
#define PRIO_TANGO_MMP_WIDESTEREO   (PRIO_TANGO_MMP_AUDIOBUFFER + 4) /*16*/

#define PRIO_TANGO_MMP_SAD          (PRIO_TANGO_MMP_AUDIOBUFFER + 5) /*17*/
#define PRIO_TANGO_MMP_RESAMP       (PRIO_TANGO_MMP_AUDIOBUFFER + 6) /*18*/
#define PRIO_TANGO_MMP_DECODER      (PRIO_TANGO_MMP_AUDIOBUFFER + 7) /*19*/
#define PRIO_TANGO_MMP_COMPRESSOR   (PRIO_TANGO_MMP_AUDIOBUFFER + 7) /*19*/

#define PRIO_TANGO_PFD              (PRIO_TANGO_MMP_DECODER + 1) /*20*/
#define PRIO_TANGO_MMP_AUDIOIN_PROC (PRIO_TANGO_MMP_DECODER + 1) /*20*/
#define PRIO_TANGO_AUDT_LINEIN      (PRIO_TANGO_MMP_DECODER + 1) /*20*/

#define PRIO_TANGO_UPDATE_EQ        21
#define PRIO_TANGO_AUDT             21
#define PRIO_TANGO_RT               21

#define PRIO_TANGO_RECO             25
#define PRIO_TANGO_PERF             25


/**
 * Blues priorities definition
 */
#define PRIO_EBC_IRQ_MNGR       1
#define PRIO_EBC_LM_SCHEDULER   1
#define PRIO_EBC_LM_TIMERSERVER 2
#define PRIO_EBC_HCI_TRANSPORT  4
#define PRIO_EBC_LM_DATA        6
#define PRIO_EBC_LM_DRIVER      7
#define PRIO_EBC_FLASH_HANDLER  7
#define PRIO_EBC_LM_CONTROL     8
#define PRIO_EBC_LM_CONNECTION  8
#define PRIO_EBC_FLASH_ERASER   8
#define PRIO_EBC_HCI_COMMANDER  11
#define PRIO_EBC_RXPKTMANAGER   12
#define PRIO_EBC_TSTTXACLDATA   12
#define PRIO_EBC_VOSLOGGER      16

#define PRIO_BLUES_TASK             20  // P2
#define PRIO_BLUES_PVSP             20  // P2
#define PRIO_BLUES_BNEP             20  // P2
#define PRIO_BLUES_GENERIC          20  // P2
#define PRIO_BLUES_L2CAP_SENDER     21
#define PRIO_BLUES_STREAMSRC        22  // P3
#define PRIO_BLUES_PIM              23
#define PRIO_BLUES_TSYNC            24  // P4
#define PRIO_BLUES_TPBSEARCH        24  // P4
#define PRIO_BLUES_TPBSORT          24
#define PRIO_BLUES_SYNCMLPARSE      24  // P4
#define PRIO_BLUES_OBEXWORKER       24  // P4
#define PRIO_BLUES_JOBWORKER        26  // P5
#define PRIO_BLUES_P4ABWORKER       26  // P5

/**
 * Soprano priorities definition
 */
#define PRIO_SOPRANO_AUDIO_OUT      4
#define PRIO_SOPRANO_AUDIO_IN       20
#define PRIO_SOPRANO_FX             (PRIO_SOPRANO_AUDIO_IN + 1)
#define PRIO_SOPRANO_RC             (PRIO_SOPRANO_AUDIO_IN + 2)
#define PRIO_SOPRANO_ASR            (PRIO_SOPRANO_AUDIO_IN + 4)
#define PRIO_SOPRANO_TTS            (PRIO_SOPRANO_AUDIO_IN + 4)
#define PRIO_SOPRANO_CB             (PRIO_SOPRANO_AUDIO_IN + 6)
#define PRIO_SOPRANO_SYNC           (PRIO_SOPRANO_AUDIO_IN + 8)

/**
 * Soul priorities definition
 */
#define PRIO_SOUL               26  // P5


/**
 * ParrotOS priorities definition
 */
#define PRIO_PARROTOS_UART      21
#define PRIO_PARROTOS_TIMER     21 // TIMER and TIMER_P4 tasks


/**
 * Flamenco priorities definition
 */
#define PRIO_FLAMENCO_FLASH     24 // P4
#define PRIO_FLAMENCO_GC        30

/**
 * Disco Thread priorities
 */

//! ---BSM and MTP devices-------
#define PRIO_DISCO_DEFAULT      (25)

//! ---iPod with iAP over USB----
#define PRIO_DISCO_IPOD_ACDC            (14)
#define PRIO_DISCO_IPOD_USB_AUDIO_READ  PRIO_DISCO_IPOD_ACDC
#define PRIO_DISCO_IPOD_INTERPRET       (16)
#define PRIO_DISCO_IPOD_AUTHENTICATION  (17)
#define PRIO_DISCO_IPOD_SENDING         (18)


//! ---iPod with iAP over UART---
//! ---additionnal threads-------
//! the polling via UART to detect the iPod attach is performed by the thread which calls disco_open
#define PRIO_DISCO_IPOD_UART_DETACH     (19)
//! the reception via USB is performed via a callback called by the USB stack: no additionnal thread
#define PRIO_DISCO_IPOD_UART_RECEPTION  (15) 

#endif //TASK_PRIORITIES_H

