//
// Dynamo tests
//

#include <cyg/kernel/kapi.h>
#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <dirent.h>
#include <time.h>
#include <cyg/fileio/fileio.h>
#include <cyg/infra/diag.h>            // HAL polled output

#include <cyg/dynamo/process.h>

cyg_process process;

extern int _binary_module_so_start;
extern int _binary_module_so_end;
extern int _binary_module_so_size;

static int
write_module(void) {
    int status, fd, ret = 0;
    void *dbase;
    cyg_uint32 dlen;

    dbase = (void *)&_binary_module_so_start;
    dlen = (cyg_uint32)&_binary_module_so_size;

    status = mount("", "/", "ramfs");
    if ( status ) {
        fprintf( stderr, "mount() returned %d\n", status );
        ret = -1;
    }
    else {
        fprintf( stderr, "writing module.so...\n" );
        fd = open( "/module.so", O_WRONLY|O_CREAT|O_TRUNC, 0644 );
        if ( fd < 0 ) {
            fprintf( stderr, "open: %s\n", strerror(errno) );
            ret = -1;
        }
        else {
            status = write(fd, dbase, dlen);
            if ( status != dlen ) {
                fprintf( stderr, "write: %s\n", strerror(errno) );
                ret = -1;
            }
            close(fd);
        }
    }
    return ret;
}

void
dynamo_test(void) {
    int status;
    cyg_handle_t handle;

    fprintf(stderr, "Dynamo tests\n" );

    status = write_module();

    dynamo_init();

    if (status == 0) {
        status = cyg_process_create( 4,       /* process priority */
                                     "process test",
                                     "/module.so",
                                     "module_entry",
                                     1,        /* process domain */
                                     16,       /* 16 threads max */
                                     16 << 20, /* 48 Mbytes */
                                     &handle,
                                     &process );

        if ( status ) {
            fprintf( stderr, "cyg_process_create() returned %d\n", status );
        }
        else {
            cyg_process_resume(handle);
        }
    }
}
